diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/advanced-emlsr-manager.h ns-3.43/src/wifi/model/eht/advanced-emlsr-manager.h
--- ns-3.42/src/wifi/model/eht/advanced-emlsr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/advanced-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2024 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef ADVANCED_EMLSR_MANAGER_H
+#define ADVANCED_EMLSR_MANAGER_H
+
+#include "default-emlsr-manager.h"
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * AdvancedEmlsrManager is an advanced EMLSR manager.
+ */
+class AdvancedEmlsrManager : public DefaultEmlsrManager
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    AdvancedEmlsrManager();
+    ~AdvancedEmlsrManager() override;
+
+  protected:
+    void DoDispose() override;
+    void DoSetWifiMac(Ptr<StaWifiMac> mac) override;
+    std::pair<bool, Time> DoGetDelayUntilAccessRequest(uint8_t linkId) override;
+    std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) override;
+    void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) override;
+
+    /**
+     * Possibly take actions when notified of the MAC header of the MPDU being received by the
+     * given PHY.
+     *
+     * \param phy the given PHY
+     * \param macHdr the MAC header of the MPDU being received
+     * \param txVector the TXVECTOR used to transmit the PSDU
+     * \param psduDuration the remaining duration of the PSDU
+     */
+    void ReceivedMacHdr(Ptr<WifiPhy> phy,
+                        const WifiMacHeader& macHdr,
+                        const WifiTxVector& txVector,
+                        Time psduDuration);
+
+    /**
+     * Use information from NAV and CCA performed by the given PHY on the given link in the last
+     * PIFS interval to determine whether the given EDCAF can start a TXOP. This function is
+     * intended to be used when the main PHY switches channel to start an UL TXOP on a link where
+     * channel access was obtained by a non-TX capable aux PHY.
+     *
+     * \param phy the PHY that performed CCA in the last PIFS interval
+     * \param linkId the ID of the given link
+     * \param edca the given EDCAF
+     */
+    void CheckNavAndCcaLastPifs(Ptr<WifiPhy> phy, uint8_t linkId, Ptr<QosTxop> edca);
+
+    /**
+     * Determine whether the main PHY shall be requested to switch to the link of an aux PHY that
+     * has gained channel access through the given AC but it is not TX capable.
+     *
+     * \param linkId the ID of the link on which the aux PHY is operating
+     * \param aci the index of the given AC
+     * \return whether the main PHY shall be requested to switch to the link of the aux PHY
+     */
+    bool RequestMainPhyToSwitch(uint8_t linkId, AcIndex aci);
+
+  private:
+    void DoNotifyTxopEnd(uint8_t linkId) override;
+    void DoNotifyIcfReceived(uint8_t linkId) override;
+    void DoNotifyUlTxopStart(uint8_t linkId) override;
+
+    bool m_useNotifiedMacHdr;      //!< whether to use the information about the MAC header of
+                                   //!< the MPDU being received (if notified by the PHY)
+    bool m_allowUlTxopInRx;        //!< whether a (main or aux) PHY is allowed to start an UL
+                                   //!< TXOP if another PHY is receiving a PPDU
+    bool m_interruptSwitching;     //!< whether a main PHY switching can be interrupted to start
+                                   //!< switching to another link
+    bool m_useAuxPhyCca;           //!< whether the CCA performed in the last PIFS interval by a
+                                   //!< non-TX capable aux PHY should be used when the main PHY
+                                   //!< ends switching to the aux PHY's link to determine whether
+                                   //!< TX can start or not
+    Time m_switchMainPhyBackDelay; //!< duration of the timer started in case of non-TX capable aux
+                                   //!< PHY when medium is sensed busy during the PIFS interval
+                                   //!< preceding/following the main PHY switch end
+    EventId m_ccaLastPifs;         //!< event scheduled in case of non-TX capable aux PHY to
+                                   //!< determine whether TX can be started based on whether
+                                   //!< the medium has been idle during the last PIFS interval
+    EventId m_switchMainPhyBackEvent; //!< event scheduled in case of non-TX capable aux PHY when
+                                      //!< medium is sensed busy during the PIFS interval
+                                      //!< preceding/following the main PHY switch end
+};
+
+} // namespace ns3
+
+#endif /* ADVANCED_EMLSR_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/ap-emlsr-manager.cc ns-3.43/src/wifi/model/eht/ap-emlsr-manager.cc
--- ns-3.42/src/wifi/model/eht/ap-emlsr-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/ap-emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,95 @@
+/*
+ * Copyright (c) 2024 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ap-emlsr-manager.h"
+
+#include "eht-configuration.h"
+#include "eht-frame-exchange-manager.h"
+
+#include "ns3/abort.h"
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/assert.h"
+#include "ns3/log.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("ApEmlsrManager");
+
+NS_OBJECT_ENSURE_REGISTERED(ApEmlsrManager);
+
+TypeId
+ApEmlsrManager::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::ApEmlsrManager").SetParent<Object>().SetGroupName("Wifi");
+    return tid;
+}
+
+ApEmlsrManager::ApEmlsrManager()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+ApEmlsrManager::~ApEmlsrManager()
+{
+    NS_LOG_FUNCTION_NOARGS();
+}
+
+void
+ApEmlsrManager::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    m_apMac = nullptr;
+    Object::DoDispose();
+}
+
+void
+ApEmlsrManager::SetWifiMac(Ptr<ApWifiMac> mac)
+{
+    NS_LOG_FUNCTION(this << mac);
+    NS_ASSERT(mac);
+    m_apMac = mac;
+
+    NS_ABORT_MSG_IF(!m_apMac->GetEhtConfiguration(), "ApEmlsrManager requires EHT support");
+    NS_ABORT_MSG_IF(m_apMac->GetNLinks() <= 1, "ApEmlsrManager can only be installed on MLDs");
+    NS_ABORT_MSG_IF(m_apMac->GetTypeOfStation() != AP,
+                    "ApEmlsrManager can only be installed on AP MLDs");
+    DoSetWifiMac(mac);
+}
+
+void
+ApEmlsrManager::DoSetWifiMac(Ptr<ApWifiMac> mac)
+{
+    NS_LOG_FUNCTION(this << mac);
+}
+
+Ptr<ApWifiMac>
+ApEmlsrManager::GetApMac() const
+{
+    return m_apMac;
+}
+
+Ptr<EhtFrameExchangeManager>
+ApEmlsrManager::GetEhtFem(uint8_t linkId) const
+{
+    return StaticCast<EhtFrameExchangeManager>(m_apMac->GetFrameExchangeManager(linkId));
+}
+
+void
+ApEmlsrManager::NotifyPsduRxOk(uint8_t linkId, Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << linkId << *psdu);
+}
+
+void
+ApEmlsrManager::NotifyPsduRxError(uint8_t linkId, Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << linkId << *psdu);
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/ap-emlsr-manager.h ns-3.43/src/wifi/model/eht/ap-emlsr-manager.h
--- ns-3.42/src/wifi/model/eht/ap-emlsr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/ap-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2024 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef AP_EMLSR_MANAGER_H
+#define AP_EMLSR_MANAGER_H
+
+#include "ns3/object.h"
+#include "ns3/wifi-phy-band.h"
+
+namespace ns3
+{
+
+class ApWifiMac;
+class EhtFrameExchangeManager;
+class Time;
+class WifiPsdu;
+class WifiTxVector;
+
+/**
+ * \ingroup wifi
+ *
+ * ApEmlsrManager is an abstract base class defining the API that EHT AP MLDs with
+ * EMLSR activated can use to handle the operations on the EMLSR links of EMLSR clients
+ */
+class ApEmlsrManager : public Object
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+    ApEmlsrManager();
+    ~ApEmlsrManager() override;
+
+    /**
+     * Set the wifi MAC. Note that it must be the MAC of an EHT AP MLD.
+     *
+     * \param mac the wifi MAC
+     */
+    void SetWifiMac(Ptr<ApWifiMac> mac);
+
+    /**
+     * This method is called when the reception of a PSDU succeeds on the given link.
+     *
+     * \param linkId the ID of the given link
+     * \param psdu the PSDU whose reception succeeded
+     */
+    virtual void NotifyPsduRxOk(uint8_t linkId, Ptr<const WifiPsdu> psdu);
+
+    /**
+     * This method is called when the reception of a PSDU fails on the given link.
+     *
+     * \param linkId the ID of the given link
+     * \param psdu the PSDU whose reception failed
+     */
+    virtual void NotifyPsduRxError(uint8_t linkId, Ptr<const WifiPsdu> psdu);
+
+    /**
+     * This method is intended to be called when the AP MLD starts transmitting an SU frame that
+     * is not addressed to EMLSR clients that were previously involved in the ongoing DL TXOP.
+     *
+     * \param psdu the PSDU being transmitted
+     * \param txVector the TXVECTOR used to transmit the PSDU
+     * \param band the PHY band in which the PSDU is being transmitted
+     * \return the delay after which the AP MLD starts the transition delay for the EMLSR client
+     */
+    virtual Time GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
+                                             const WifiTxVector& txVector,
+                                             WifiPhyBand band) = 0;
+
+    /**
+     * \return whether the AP MLD shall double the CW upon CTS timeout after an MU-RTS in case
+     *         all the clients solicited by the MU-RTS are EMLSR clients that have sent (or
+     *         are sending) a frame to the AP
+     */
+    virtual bool UpdateCwAfterFailedIcf() = 0;
+
+  protected:
+    void DoDispose() override;
+
+    /**
+     * Allow subclasses to take actions when the MAC is set.
+     *
+     * \param mac the wifi MAC
+     */
+    virtual void DoSetWifiMac(Ptr<ApWifiMac> mac);
+
+    /**
+     * \return the MAC of the AP MLD managed by this AP EMLSR Manager.
+     */
+    Ptr<ApWifiMac> GetApMac() const;
+
+    /**
+     * \param linkId the ID of the given link
+     * \return the EHT FrameExchangeManager attached to the AP operating on the given link
+     */
+    Ptr<EhtFrameExchangeManager> GetEhtFem(uint8_t linkId) const;
+
+  private:
+    Ptr<ApWifiMac> m_apMac; //!< the MAC of the managed AP MLD
+};
+
+} // namespace ns3
+
+#endif /* AP_EMLSR_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/default-ap-emlsr-manager.cc ns-3.43/src/wifi/model/eht/default-ap-emlsr-manager.cc
--- ns-3.42/src/wifi/model/eht/default-ap-emlsr-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/default-ap-emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2023 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "default-ap-emlsr-manager.h"
+
+#include "ns3/log.h"
+#include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("DefaultApEmlsrManager");
+
+NS_OBJECT_ENSURE_REGISTERED(DefaultApEmlsrManager);
+
+TypeId
+DefaultApEmlsrManager::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::DefaultApEmlsrManager")
+                            .SetParent<ApEmlsrManager>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<DefaultApEmlsrManager>();
+    return tid;
+}
+
+DefaultApEmlsrManager::DefaultApEmlsrManager()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+DefaultApEmlsrManager::~DefaultApEmlsrManager()
+{
+    NS_LOG_FUNCTION_NOARGS();
+}
+
+Time
+DefaultApEmlsrManager::GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
+                                                   const WifiTxVector& txVector,
+                                                   WifiPhyBand band)
+{
+    NS_LOG_FUNCTION(this << psdu << txVector << band);
+    // EMLSR clients switch back to listening operation at the end of the PPDU
+    return WifiPhy::CalculateTxDuration(psdu, txVector, band);
+}
+
+bool
+DefaultApEmlsrManager::UpdateCwAfterFailedIcf()
+{
+    return true;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/default-ap-emlsr-manager.h ns-3.43/src/wifi/model/eht/default-ap-emlsr-manager.h
--- ns-3.42/src/wifi/model/eht/default-ap-emlsr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/default-ap-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2024 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef DEFAULT_AP_EMLSR_MANAGER_H
+#define DEFAULT_AP_EMLSR_MANAGER_H
+
+#include "ap-emlsr-manager.h"
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * DefaultApEmlsrManager is the default AP EMLSR manager.
+ */
+class DefaultApEmlsrManager : public ApEmlsrManager
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    DefaultApEmlsrManager();
+    ~DefaultApEmlsrManager() override;
+
+    Time GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
+                                     const WifiTxVector& txVector,
+                                     WifiPhyBand band) override;
+    bool UpdateCwAfterFailedIcf() override;
+};
+
+} // namespace ns3
+
+#endif /* DEFAULT_AP_EMLSR_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/default-emlsr-manager.cc ns-3.43/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.42/src/wifi/model/eht/default-emlsr-manager.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/eht/default-emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -24,6 +13,7 @@
 #include "ns3/boolean.h"
 #include "ns3/channel-access-manager.h"
 #include "ns3/log.h"
+#include "ns3/qos-txop.h"
 #include "ns3/wifi-mpdu.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-phy.h"
@@ -51,11 +41,19 @@
                           "no PHY will be listening on that EMLSR link).",
                           BooleanValue(true),
                           MakeBooleanAccessor(&DefaultEmlsrManager::m_switchAuxPhy),
+                          MakeBooleanChecker())
+            .AddAttribute("PutAuxPhyToSleep",
+                          "Whether Aux PHY should be put into sleep mode while the Main PHY "
+                          "is operating on the same link as the Aux PHY (this only matters "
+                          "when the Aux PHY does not switch channel).",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&DefaultEmlsrManager::m_auxPhyToSleep),
                           MakeBooleanChecker());
     return tid;
 }
 
 DefaultEmlsrManager::DefaultEmlsrManager()
+    : m_mainPhySwitchInfo{}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -96,19 +94,49 @@
 }
 
 void
-DefaultEmlsrManager::NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId)
-{
-    NS_LOG_FUNCTION(this << currLinkId << nextLinkId);
+DefaultEmlsrManager::NotifyMainPhySwitch(std::optional<uint8_t> currLinkId,
+                                         uint8_t nextLinkId,
+                                         Time duration)
+{
+    NS_LOG_FUNCTION(this << (currLinkId ? std::to_string(*currLinkId) : "") << nextLinkId
+                         << duration.As(Time::US));
+
+    // if currLinkId has no value (i.e., the main PHY is not operating on any link), it means that
+    // the main PHY is switching
+    const auto now = Simulator::Now();
+    NS_ASSERT_MSG(currLinkId || m_mainPhySwitchInfo.end >= now,
+                  "No current link ID provided nor valid main PHY switch information stored");
+    m_mainPhySwitchInfo.from = currLinkId.value_or(m_mainPhySwitchInfo.from);
+    m_mainPhySwitchInfo.end = now + duration;
 
     if (m_switchAuxPhy)
     {
-        // switch channel on Aux PHY so that it operates on the link on which the main PHY was
+        // cancel any previously requested aux PHY switch
+        m_auxPhySwitchEvent.Cancel();
+
+        if (nextLinkId == m_mainPhySwitchInfo.from)
+        {
+            // the main PHY is now switching to the link where it is coming from; nothing else
+            // needs to be done
+            return;
+        }
+
+        // schedule Aux PHY switch so that it operates on the link on which the main PHY was
         // operating
-        SwitchAuxPhy(nextLinkId, currLinkId);
+        auto auxPhy = GetStaMac()->GetWifiPhy(nextLinkId);
+
+        NS_LOG_DEBUG("Aux PHY (" << auxPhy << ") operating on link " << +nextLinkId
+                                 << " will switch to link " << +currLinkId.value() << " in "
+                                 << duration.As(Time::US));
+
+        m_auxPhySwitchEvent =
+            Simulator::Schedule(duration, [=, this, prevLinkId = m_mainPhySwitchInfo.from]() {
+                SwitchAuxPhy(auxPhy, nextLinkId, prevLinkId);
+            });
         return;
     }
 
-    if (currLinkId != GetMainPhyId())
+    if (currLinkId.has_value() && currLinkId != GetMainPhyId())
     {
         // the main PHY is leaving a non-primary link, hence an aux PHY needs to be reconnected
         NS_ASSERT_MSG(
@@ -116,18 +144,40 @@
             "There should be an aux PHY to reconnect when the main PHY leaves a non-primary link");
 
         // the Aux PHY is not actually switching (hence no switching delay)
-        GetStaMac()->NotifySwitchingEmlsrLink(m_auxPhyToReconnect, currLinkId, Seconds(0));
-        SetCcaEdThresholdOnLinkSwitch(m_auxPhyToReconnect, currLinkId);
-        m_auxPhyToReconnect = nullptr;
+        GetStaMac()->NotifySwitchingEmlsrLink(m_auxPhyToReconnect, *currLinkId, Seconds(0));
+        // resume aux PHY from sleep (once reconnected to its original link)
+        m_auxPhyToReconnect->ResumeFromSleep();
+        SetCcaEdThresholdOnLinkSwitch(m_auxPhyToReconnect, *currLinkId);
     }
 
+    // if currLinkId has no value, it means that the main PHY switch is interrupted, hence reset
+    // the aux PHY to reconnect and cancel the event to put the aux PHY to sleep. Doing so when
+    // the main PHY is leaving the primary link makes no harm (the aux PHY to reconnect and the
+    // event to put the aux PHY to sleep are set below), thus no need to add an 'if' condition
+    m_auxPhyToReconnect = nullptr;
+    m_auxPhyToSleepEvent.Cancel();
+
     if (nextLinkId != GetMainPhyId())
     {
         // the main PHY is moving to a non-primary link and the aux PHY does not switch link
         m_auxPhyToReconnect = GetStaMac()->GetWifiPhy(nextLinkId);
+
+        if (m_auxPhyToSleep)
+        {
+            // aux PHY can be put into sleep mode when the main PHY completes the channel switch
+            m_auxPhyToSleepEvent =
+                Simulator::Schedule(duration, &WifiPhy::SetSleepMode, m_auxPhyToReconnect);
+        }
     }
 }
 
+std::pair<bool, Time>
+DefaultEmlsrManager::DoGetDelayUntilAccessRequest(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+    return {true, Time{0}}; // start the TXOP
+}
+
 void
 DefaultEmlsrManager::DoNotifyIcfReceived(uint8_t linkId)
 {
@@ -146,34 +196,128 @@
     NS_LOG_FUNCTION(this << linkId);
 
     // switch main PHY to the previous link, if needed
-    if (!m_switchAuxPhy && m_auxPhyToReconnect)
+    if (!m_switchAuxPhy)
     {
-        auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+        SwitchMainPhyBackToPrimaryLink(linkId);
+    }
+}
 
-        // the main PHY may be switching at the end of a TXOP when, e.g., the main PHY starts
-        // switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the CTS
-        // is not received and the UL TXOP ends before the main PHY channel switch is completed.
-        // In such cases, wait until the main PHY channel switch is completed before requesting
-        // a new channel switch.
-        // Backoff shall not be reset on the link left by the main PHY because a TXOP ended and
-        // a new backoff value must be generated.
-        if (!mainPhy->IsStateSwitching())
-        {
-            SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
-        }
-        else
+void
+DefaultEmlsrManager::SwitchMainPhyBackToPrimaryLink(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    NS_ABORT_MSG_IF(m_switchAuxPhy, "This method can only be called when SwitchAuxPhy is false");
+
+    if (!m_auxPhyToReconnect)
+    {
+        return;
+    }
+
+    auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+
+    // the main PHY may be switching at the end of a TXOP when, e.g., the main PHY starts
+    // switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the CTS
+    // is not received and the UL TXOP ends before the main PHY channel switch is completed.
+    // In such cases, wait until the main PHY channel switch is completed before requesting
+    // a new channel switch and cancel the event to put the aux PHY to sleep.
+    // Backoff shall not be reset on the link left by the main PHY because a TXOP ended and
+    // a new backoff value must be generated.
+    if (!mainPhy->IsStateSwitching())
+    {
+        SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
+    }
+    else
+    {
+        m_auxPhyToSleepEvent.Cancel();
+        Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
+            // request the main PHY to switch back to the primary link only if in the meantime
+            // no TXOP started on another link (which will require the main PHY to switch link)
+            if (!GetEhtFem(linkId)->UsingOtherEmlsrLink())
+            {
+                SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
+            }
+        });
+    }
+}
+
+void
+DefaultEmlsrManager::SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci)
+{
+    NS_LOG_FUNCTION(this << linkId << aci);
+    NS_LOG_DEBUG("Do nothing, aux PHY is not TX capable");
+}
+
+Time
+DefaultEmlsrManager::GetTimeToCtsEnd(uint8_t linkId) const
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    auto phy = GetStaMac()->GetWifiPhy(linkId);
+    NS_ASSERT_MSG(phy, "No PHY operating on link " << +linkId);
+
+    // we have to check whether the main PHY can switch to take over the UL TXOP
+    const auto stationManager = GetStaMac()->GetWifiRemoteStationManager(linkId);
+    const auto bssid = GetEhtFem(linkId)->GetBssid();
+    const auto allowedWidth = GetEhtFem(linkId)->GetAllowedWidth();
+
+    const auto rtsTxVector = stationManager->GetRtsTxVector(bssid, allowedWidth);
+    const auto rtsTxTime = phy->CalculateTxDuration(GetRtsSize(), rtsTxVector, phy->GetPhyBand());
+    const auto ctsTxVector = stationManager->GetCtsTxVector(bssid, rtsTxVector.GetMode());
+    const auto ctsTxTime = phy->CalculateTxDuration(GetCtsSize(), ctsTxVector, phy->GetPhyBand());
+
+    // the main PHY shall terminate the channel switch at the end of CTS reception;
+    // the time remaining to the end of CTS reception includes two propagation delays
+    return rtsTxTime + phy->GetSifs() + ctsTxTime + MicroSeconds(2 * MAX_PROPAGATION_DELAY_USEC);
+}
+
+std::pair<bool, Time>
+DefaultEmlsrManager::GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+    auto timeToCtsEnd = GetTimeToCtsEnd(linkId);
+    auto switchingTime = mainPhy->GetChannelSwitchDelay();
+
+    switch (mainPhy->GetState()->GetState())
+    {
+    case WifiPhyState::SWITCHING:
+        // the main PHY is switching (to another link), hence the remaining time to
+        // the end of the current channel switch needs to be added up
+        switchingTime += mainPhy->GetDelayUntilIdle();
+        [[fallthrough]];
+    case WifiPhyState::RX:
+    case WifiPhyState::IDLE:
+    case WifiPhyState::CCA_BUSY:
+        if (switchingTime > timeToCtsEnd)
         {
-            Simulator::Schedule(mainPhy->GetDelayUntilIdle(), [=, this]() {
-                // request the main PHY to switch back to the primary link only if in the meantime
-                // no TXOP started on another link (which will require the main PHY to switch link)
-                if (!GetEhtFem(linkId)->UsingOtherEmlsrLink())
-                {
-                    SwitchMainPhy(GetMainPhyId(), false, DONT_RESET_BACKOFF, REQUEST_ACCESS);
-                }
-            });
+            // switching takes longer than RTS/CTS exchange, release channel
+            NS_LOG_DEBUG("Not enough time for main PHY to switch link (main PHY state: "
+                         << mainPhy->GetState()->GetState() << ")");
+            // retry channel access when the CTS was expected to be received
+            return {false, timeToCtsEnd};
         }
-        return;
+        break;
+    default:
+        NS_ABORT_MSG("Main PHY cannot be in state " << mainPhy->GetState()->GetState());
     }
+
+    // TXOP can be started, schedule main PHY switch. Main PHY shall terminate the channel switch
+    // at the end of CTS reception
+    const auto delay = timeToCtsEnd - mainPhy->GetChannelSwitchDelay();
+
+    NS_ASSERT(delay.IsPositive());
+    NS_LOG_DEBUG("Schedule main Phy switch in " << delay.As(Time::US));
+    m_ulMainPhySwitch[linkId] = Simulator::Schedule(delay,
+                                                    &DefaultEmlsrManager::SwitchMainPhy,
+                                                    this,
+                                                    linkId,
+                                                    false,
+                                                    RESET_BACKOFF,
+                                                    DONT_REQUEST_ACCESS);
+
+    return {true, Time{0}};
 }
 
 } // namespace ns3
